Unit IIS9R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS9R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var C :Array of Real; var IERR :Integer);

implementation

procedure IIS9R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var C :Array of Real; var IERR :Integer);
var
N0,I :Integer;
RM3,T1,RM2,RM1,RM4,T2,B :Real;
const
HALF :Real = 0.5;
ONE :Real = 1.0;
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
if ( NX > 3 ) 
 then goto _1;
IERR := 65;
goto _9;
_1:
for I:=2 to NX do
 begin
  if ( X[I-1] > X[I-2] ) 
   then goto _2;
  IERR := 66;
  goto _9;
_2:
 end;
IERR := 0;
RM3 := (Y[1]-Y[0])/(X[1]-X[0]);
T1 := RM3-(Y[1]-Y[2])/(X[1]-X[2]);
RM2 := RM3+T1;
RM1 := RM2+T1;
N0 := NX-2;
for I:=1 to NX do
 begin
  if ( I > N0 ) 
   then goto _3;
  RM4 := (Y[I+1]-Y[I+0])/(X[I+1]-X[I+0]);
  goto _4;
_3:
  RM4 := RM3-RM2+RM3;
_4:
  T1 := Abs(RM4-RM3);
  T2 := Abs(RM2-RM1);
  B := T1+T2;
  if ( B <> ZERO ) 
   then goto _5;
  C[(I-1)+0*NX] := HALF*(RM2+RM3);
  goto _6;
_5:
  C[(I-1)+0*NX] := (T1*RM2+T2*RM3)/B;
_6:
  RM1 := RM2;
  RM2 := RM3;
  RM3 := RM4;
_7:
 end;
N0 := NX-1;
for I:=1 to N0 do
 begin
  T1 := ONE/(X[I+0]-X[I-1]);
  T2 := (Y[I+0]-Y[I-1])*T1;
  B := (C[(I-1)+0*NX]+C[(I+0)+0*NX]-T2-T2)*T1;
  C[(I-1)+2*NX] := B*T1;
  C[(I-1)+1*NX] := -B+(T2-C[(I-1)+0*NX])*T1;
_8:
 end;
_9:
if ( IERR <> 0 ) 
 then UTII10(IERR,9);
end;

end.
